<?php
class UNL_Search
{
    /**
     * Array of Google JS API keys to use
     *
     * @var array
     */
    public static $jsapiKeys = array();
    
    public static $mode = 'production';
    
    public static $linkedCSEServer = 'http://www1.unl.edu/search/linkedcse/';

    function __construct()
    {

    }

    public static function removeRelativePaths($html, $base_url)
    {
        $needles = array('href="', 'src="', 'background="');
        $new_base_url = $base_url;
        $base_url_parts = parse_url($base_url);

        if (substr($base_url,-1) != '/') {
            if (isset($base_url_parts['path'])) {
                $path = pathinfo($base_url_parts['path']);
            } else {
                $path = pathinfo('/');
            }
            $new_base_url = substr($new_base_url, 0, strlen($new_base_url)-strlen($path['basename']));
        }

        foreach ($needles as $needle) {
            $new_txt = '';
            while ($pos = strpos($html, $needle)) {
                $pos += strlen($needle);
                if (substr($html,$pos,7) != 'http://'
                     && substr($html,$pos,8) != 'https://'
                     && substr($html,$pos,6) != 'ftp://'
                     && substr($html,$pos,9) != 'mailto://') {
                     if (substr($html,$pos,1) == '/') {
                         $new_base_url = $base_url_parts['scheme'].'://'.$base_url_parts['host'];
                     }
                     $new_txt .= substr($html,0,$pos).$new_base_url;
                } else {
                    $new_txt .= substr($html,0,$pos);
                }
                $html = substr($html,$pos);
            }
            $html = $new_txt.$html;
        }
        return $html;
    }
    
    /**
     * Returns a UNL_Templates_Scanner of the given URL or false on failure
     *
     * @param string $referrer
     * @return boolean|UNL_Templates_Scanner
     */
    public static function getScannedPage($referrer)
    {
        if ($referrer == 'http://www.unl.edu' ||
            !preg_match('/^https?/', $referrer) ||
            !filter_var($referrer, FILTER_VALIDATE_URL, FILTER_FLAG_SCHEME_REQUIRED)
        ) {
            return false;
        }
        
        $scanned = @file_get_contents($referrer);
        if (!$scanned) {
            return false;
        }
        
        return new \UNL\Templates\Scanner($scanned);
    }

    /**
     * Return an API key
     *
     * @return string
     */
    public static function getJSAPIKey()
    {
        if (empty(self::$jsapiKeys)) {
            return '';
        }

        shuffle(self::$jsapiKeys);
        return self::$jsapiKeys[0];
    }

    public static function getLinkedCSEUrl($referrer)
    {
        return self::$linkedCSEServer . '?u=' . urlencode($referrer);
    }
    
    public static function getProjectRoot()
    {
        return dirname(dirname(__DIR__));
    }
}
