<?php
class UNL_Search_CSEGenerator
{
    public static function generateCSE($url)
    {
        $xml = '<?xml version="1.0" encoding="UTF-8" ?>
<GoogleCustomizations>
    <CustomSearchEngine>
        <Title>UNL Custom Search Engine for '. htmlentities($url, ENT_QUOTES) . '</Title>
        <Description>This custom search engine was automatically generated by the UNL Web Developer Network.</Description>
        <Context>
          <BackgroundLabels>
            <Label name="_cse_localsite" mode="FILTER" />
            <Label name="_cse_exclude_localsite" mode="ELIMINATE" />
          </BackgroundLabels>
        </Context>
        <LookAndFeel nonprofit="true" />
    </CustomSearchEngine>';
        $xml .= '
    <Annotations>';
        foreach (UNL_Search_CSEGenerator::getIncludedSites($url) as $include) {
            $xml .= "
        <Annotation about=\"$include*\">
          <Label name=\"_cse_localsite\"/>
        </Annotation>";
        }
        foreach (UNL_Search_CSEGenerator::getExcludedSites($url) as $exclude) {
            $xml .= "
                <Annotation about=\"$exclude*\">
                  <Label name=\"_cse_exclude_localsite\" />
                </Annotation>";
        }
        $xml .= '
    </Annotations>
</GoogleCustomizations>';
        return $xml;
    }

    public static function getIncludedSites($baseurl)
    {
        $baseurl = str_replace('http://', '', $baseurl);
        return array($baseurl);
    }

    public static function getExcludedSites($baseurl)
    {
        return array();
    }
}
?>